
--- Surface:	MiniLab3
--- Developer:	Farès MEZDOUR
--- Version:	0.10 / Marketing

--- Copyright (c) 2022 Farès MEZDOUR


-----------------
---- Defines ----
-----------------


-- init globals varaiables

MEMORY = 0
g_tap_tempo_led = 0
timeout = 1500
REC_STATUS = "00"
PLAY_STATUS = "00"
REC_STATUS_old = "00"
PLAY_STATUS_old = "00"
timed_screen = 0
g_record_button_state = "OFF"
g_loop_button_state = "OFF"
g_metro_button_state = "ON"
g_pause_play_button_state = "Pause"
g_switch_button_state = "channel"
g_song_pos_state = 0
g_song_pos = nil
g_bar = 0
g_beat = 0
g_boucle = 0
g_global_time = 0
g_init_param = 0
g_tempobpm = nil

item = nil

g_record_button_index = 1
g_stop_button_index = 2
g_pause_play_button_index = 3
g_loop_button_index = 4
g_rewind_button_index = 5
g_fast_forward_button_index = 6
g_taptempo_button_index = 7
g_metro_button_index = 8

g_switch_index = 9
g_channel_index = 10
g_preset_index = 11
g_song_pos_index = 12

g_fader_1 = 13
g_fader_2 = 14
g_fader_3 = 15
g_fader_4 = 16

g_knob_1 = 17
g_knob_2 = 18
g_knob_3 = 19
g_knob_4 = 20
g_knob_5 = 21
g_knob_6 = 22
g_knob_7 = 23
g_knob_8 = 24

g_lcd_line1_index = 25
g_lcd_line2_index = 26

g_tempobpm_index = 27
g_bar_index = 28
g_beat_index = 29

g_keyboard = 30
g_pitchbend = 31
g_modwheel = 32
g_damper_pedal = 33



PAD_MATRIX = {
    	52,	53,	54,	55,
    	56,	57,	58,	59,
    	68,	69,	70,	71,
    	72,	73,	74,	75,
	}

PAD_MATRIX_STATE = {
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
	}

PAD_ID = 0


g_fader_1_last_param = ""
g_fader_2_last_param = ""
g_fader_3_last_param = ""
g_fader_4_last_param = ""
g_knob_1_last_param = ""
g_knob_2_last_param = ""
g_knob_3_last_param = ""
g_knob_4_last_param = ""
g_knob_5_last_param = ""
g_knob_6_last_param = ""
g_knob_7_last_param = ""
g_knob_8_last_param = ""

g_fader_1_current_value_str = ""
g_fader_2_current_value_str = ""
g_fader_3_current_value_str = ""
g_fader_4_current_value_str = ""
g_knob_1_current_value_str = ""
g_knob_2_current_value_str = ""
g_knob_3_current_value_str = ""
g_knob_4_current_value_str = ""
g_knob_5_current_value_str = ""
g_knob_6_current_value_str = ""
g_knob_7_current_value_str = ""
g_knob_8_current_value_str = "" 

g_fader_1_current_value_int = 0
g_fader_2_current_value_int = 0
g_fader_3_current_value_int = 0
g_fader_4_current_value_int = 0
g_knob_1_current_value_int = 0
g_knob_2_current_value_int = 0
g_knob_3_current_value_int = 0
g_knob_4_current_value_int = 0
g_knob_5_current_value_int = 0
g_knob_6_current_value_int = 0
g_knob_7_current_value_int = 0
g_knob_8_current_value_int = 0 

g_fader_1_HW_value = 0
g_fader_2_HW_value = 0
g_fader_3_HW_value = 0
g_fader_4_HW_value = 0
g_knob_1_HW_value = 0
g_knob_2_HW_value = 0
g_knob_3_HW_value = 0
g_knob_4_HW_value = 0
g_knob_5_HW_value = 0
g_knob_6_HW_value = 0
g_knob_7_HW_value = 0
g_knob_8_HW_value = 0

ParamList = {
	
}


faders_on_off = true

now_time = 0
g_last_input_time= 0
g_last_input_item=-1

g_lcd_line1_new_text = ""
g_lcd_line1_old_text = ""
g_lcd_line2_new_text = ""
g_lcd_line2_old_text = ""


last_param = ""

NON_DISPAYED_ITEM_INDEXES = {
		30,
		31,
		32,
		33
}




function remote_init(manufacturer, model)
	local items = {

		-- index 1
		{name="record", input="button", output="value"},
		{name="stop", input="button", output="value"},
		{name="play", input="button", output="value",  modes={"Play", "Pause"}}, 
		{name="loop", input="button", output="value"},
		{name="rew", input="button", output="value"},
		{name="fwd", input="button", output="value"},
		{name="taptempo", input="button", output="value"},
		{name="metro", input="button", output="value"},
		{name="switch", input="button", output="value"},
		{name="channel", input="delta"},
		{name="preset", input="delta"},
		{name="songPos", input="delta"},
		
		-- index 13
		{name="fader1", input="value", output="value", min=0, max=127},
		{name="fader2", input="value", output="value", min=0, max=127},
		{name="fader3", input="value", output="value", min=0, max=127},
		{name="fader4", input="value", output="value", min=0, max=127},

		{name="encoder1", input="value", output="value", min=0, max=127},
		{name="encoder2", input="value", output="value", min=0, max=127},
		{name="encoder3", input="value", output="value", min=0, max=127},
		{name="encoder4", input="value", output="value", min=0, max=127},
		{name="encoder5", input="value", output="value", min=0, max=127},
		{name="encoder6", input="value", output="value", min=0, max=127},
		{name="encoder7", input="value", output="value", min=0, max=127},
		{name="encoder8", input="value", output="value", min=0, max=127},

		-- index 25
		{name="lcd-1", output="text"},
		{name="lcd-2", output="text"},
		{name="tempo", output="value", min=1, max=999},
		{name="bar", output="text"},
		{name="beat", output="text"},


		{name="Keyboard", input="keyboard"},
		{name="Pitch Bend", input="value", min=0, max=16384},
		{name="Mod Wheel", input="value", min=0, max=127},
		{name="Damper Pedal", input="value", min=0, max=127},


	}
	remote.define_items(items)

	local inputs = {
		{pattern="e? xx yy", name="Pitch Bend", value="y*128 + x"},
		{pattern="b0 01 xx", name="Mod Wheel"},
		{pattern="b0 40 xx", name="Damper Pedal"},
		{pattern="<100x>? yy zz", name="Keyboard"},



		{pattern="b? 0e xx", name="fader1", value="x"},
		{pattern="b? 0f xx", name="fader2", value="x"},
		{pattern="b? 1e xx", name="fader3", value="x"},
		{pattern="b? 1f xx", name="fader4", value="x"},

		{pattern="b? 56 xx", name="encoder1", value="x"},
		{pattern="b? 57 xx", name="encoder2", value="x"},
		{pattern="b? 59 xx", name="encoder3", value="x"},
		{pattern="b? 5a xx", name="encoder4", value="x"},
		{pattern="b? 6e xx", name="encoder5", value="x"},
		{pattern="b? 6f xx", name="encoder6", value="x"},
		{pattern="b? 74 xx", name="encoder7", value="x"},
		{pattern="b? 75 xx", name="encoder8", value="x"},

		{pattern="b? 1d <?x??>?", name="songPos"},		

	}
	remote.define_auto_inputs(inputs)

	--Auto outputs
	local outputs = {
		{name="record", pattern="F0 00 20 6B 7F 42 02 02 16 5A xF 00 00 F7", x = "value*7"},
		{name="play", pattern="F0 00 20 6B 7F 42 02 02 16 59 00 xF 00 F7", x = "value*7"},
		{name="stop", pattern="F0 00 20 6B 7F 42 02 02 16 58 xF yF zF F7", x = "value*7", y = "value*7", z = "value*7"},
		{name="taptempo", pattern="F0 00 20 6B 7F 42 02 02 16 5B xF yF zF F7", x = "value*7", y = "value*7", z = "value*7"},
		{name="loop", pattern="F0 00 20 6B 7F 42 02 02 16 57 xF yF 00 F7", x = "value*7", y = "value*7"},
	
	}
	remote.define_auto_outputs(outputs)
end

----------------------------
---- Remote Auto-Detect ----
----------------------------

function remote_probe(manufacturer,model,prober)


	assert(model == "MiniLab3")
	local controlRequest="f0 7e 7f 06 01 f7"
	local controlResponse="f0 7e 7f 06 02 00 20 6b 02 00 04 04 ?? ?? ?? ?? f7"
	return {
		request=controlRequest,
		response=controlResponse
	}


end


function remote_on_auto_input(item_index) 
	if not table.contains(NON_DISPAYED_ITEM_INDEXES, item_index) then
		g_last_input_time=remote.get_time_ms()
		timed_screen = 1
	end
end


----------------------------
-- Update Global variable --
----------------------------



function toggle_pause_play_button_state()
	if g_pause_play_button_state == "Play" then
		g_pause_play_button_state = "Pause" 
	else
		g_pause_play_button_state = "Play"
	end
	return g_pause_play_button_state
end


function toggle_record_button_state()
	-- Toggle the index of the record Button
	
	if g_record_button_state == "ON" then
		g_record_button_state = "OFF" 
	else
		g_record_button_state = "ON"
	end
	return g_record_button_state
end


function toggle_loop_button_state()
	-- Toggle the index of the loop Button
	
	if g_loop_button_state == "ON" then
		g_loop_button_state = "OFF" 
	else
		g_loop_button_state = "ON"
	end
	return g_loop_button_state
end


function toggle_metro_button_state()
	-- Toggle the index of the metro Button
	
	if g_metro_button_state == "ON" then
		g_metro_button_state = "OFF" 
	else
		g_metro_button_state = "ON"
	end
	return g_metro_button_state
end


function toggle_switch_button_state()
	-- Toggle the index of the metro Button
	
	if g_switch_button_state == "channel" then
		g_switch_button_state = "pre" 
	else
		g_switch_button_state = "channel"
	end
	return g_switch_button_state
end







function remote_set_state(changed_items) --handle incoming changes sent by Reason
	

	for i,item_index in ipairs(changed_items) do

		local is_enabled = nil

		-- if (now_time-g_last_input_time) < 1000 then

		if item_index==g_lcd_line1_index then
			--g_is_lcd_enabled=remote.is_item_enabled(item_index)
			g_lcd_line1_new_text=remote.get_item_text_value(item_index)
		end

		if item_index==g_lcd_line2_index then
			--g_is_lcd_enabled=remote.is_item_enabled(item_index)
			g_lcd_line2_new_text=remote.get_item_text_value(item_index)
		
		end


		if item_index==g_knob_1 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_knob_1_last_param = remote.get_item_short_name(item_index)
				g_knob_1_current_value_str = remote.get_item_text_value(item_index)
				g_knob_1_current_value_int = tonumber(remote.get_item_value(item_index))
			end


		elseif item_index==g_knob_2 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_knob_2_last_param = remote.get_item_short_name(item_index)
				g_knob_2_current_value_str = remote.get_item_text_value(item_index)
				g_knob_2_current_value_int = remote.get_item_value(item_index)
			end
		

		elseif item_index==g_knob_3 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_knob_3_last_param = remote.get_item_short_name(item_index)
				g_knob_3_current_value_str = remote.get_item_text_value(item_index)
				g_knob_3_current_value_int = remote.get_item_value(item_index)
			end

		
		elseif item_index==g_knob_4 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_knob_4_last_param = remote.get_item_short_name(item_index)
				g_knob_4_current_value_str = remote.get_item_text_value(item_index)
				g_knob_4_current_value_int = remote.get_item_value(item_index)
			end

		
		elseif item_index==g_knob_5 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_knob_5_last_param = remote.get_item_short_name(item_index)
				g_knob_5_current_value_str = remote.get_item_text_value(item_index)
				g_knob_5_current_value_int = remote.get_item_value(item_index)
			end


		elseif item_index==g_knob_6 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_knob_6_last_param = remote.get_item_short_name(item_index)
				g_knob_6_current_value_str = remote.get_item_text_value(item_index)
				g_knob_6_current_value_int = remote.get_item_value(item_index)
			end


		elseif item_index==g_knob_7 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_knob_7_last_param = remote.get_item_short_name(item_index)
				g_knob_7_current_value_str = remote.get_item_text_value(item_index)
				g_knob_7_current_value_int = remote.get_item_value(item_index)
			end


		elseif item_index==g_knob_8 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_knob_8_last_param = remote.get_item_short_name(item_index)
				g_knob_8_current_value_str = remote.get_item_text_value(item_index)
				g_knob_8_current_value_int = remote.get_item_value(item_index)
			end


		elseif item_index==g_fader_1 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_fader_1_last_param = remote.get_item_short_name(item_index)
				g_fader_1_current_value_str = remote.get_item_text_value(item_index)
				g_fader_1_current_value_int = remote.get_item_value(item_index)
			end

		
		elseif item_index==g_fader_2 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_fader_2_last_param = remote.get_item_short_name(item_index)
				g_fader_2_current_value_str = remote.get_item_text_value(item_index)
				g_fader_2_current_value_int = remote.get_item_value(item_index)
			end


		elseif item_index==g_fader_3 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_fader_3_last_param = remote.get_item_short_name(item_index)
				g_fader_3_current_value_str = remote.get_item_text_value(item_index)
				g_fader_3_current_value_int = remote.get_item_value(item_index)
			end


		elseif item_index==g_fader_4 then
			is_enabled = remote.is_item_enabled(item_index)
			if is_enabled then
				g_fader_4_last_param = remote.get_item_short_name(item_index)
				g_fader_4_current_value_str = remote.get_item_text_value(item_index)
				g_fader_4_current_value_int = remote.get_item_value(item_index)
			end


		elseif item_index==g_record_button_index then
			if remote.get_item_value(item_index)==1 then
				g_record_button_state = "ON"
				REC_STATUS = "03"
			else 
				g_record_button_state = "OFF"
				REC_STATUS = "00"
			end
		

		elseif item_index==g_pause_play_button_index then
			if remote.get_item_value(item_index)==1 then
				g_pause_play_button_state = "Play"
				PLAY_STATUS = "02"
			else 
				g_pause_play_button_state = "Pause"
				PLAY_STATUS = "00"
			end
		
		elseif item_index==g_loop_button_index then
			if remote.get_item_value(item_index)==1 then
				g_loop_button_state = "ON"
			else 
				g_loop_button_state = "OFF"
			end


		elseif item_index==g_tempobpm_index then
			g_tempobpm = remote.get_item_text_value(item_index)

		
		elseif item_index==g_bar_index then
			g_bar = remote.get_item_text_value(item_index)
		
				
		elseif item_index==g_beat_index then
			g_beat = remote.get_item_text_value(item_index)
		end	
	
	end


	now_time = remote.get_time_ms()
	if timed_screen == 1 then
		if (now_time-g_last_input_time) > timeout then
			timed_screen = 0
			g_last_input_index = 100
		end
	end

end


-------------------------------
-- Processing incoming event --
-------------------------------


function remote_process_midi(event)

	g_global_time = remote.get_time_ms()

	-- Record
	ret = remote.match_midi("b? 6c 7F",event)
	if ret~=nil then
		g_last_input_index = 100;
		local msg={ time_stamp=event.time_stamp, item=g_record_button_index, value=1}
		remote.handle_input(msg)
		--remote_on_auto_input(g_last_input_index)
	end


	-- Stop
	ret = remote.match_midi("b? 6a 7f",event)
	if ret~=nil then
		g_pause_play_button_state = "Stop"
		g_last_input_index = 100;
		local msg={ time_stamp=event.time_stamp, item=g_stop_button_index, value=1}
		remote.handle_input(msg)
		g_song_pos_state = 0
		--g_time_pos = get_time_pos(g_song_pos_state)
		--remote_on_auto_input(g_last_input_index)
	end


	-- Play
	ret = remote.match_midi("b? 6B 7f",event)
	if ret~=nil then
		g_last_input_index = 100
		if g_pause_play_button_state == "Play" then
			local msg={ time_stamp=event.time_stamp, item=g_pause_play_button_index, value=1 }
			remote.handle_input(msg)
			--remote_on_auto_input(g_last_input_index)
		else
			local msg={ time_stamp=event.time_stamp, item=g_pause_play_button_index, value=1 }
			remote.handle_input(msg)
			--remote_on_auto_input(g_last_input_index)
		end
		--g_time_pos = get_time_pos(g_song_pos_state)
	end


	-- Loop
	ret = remote.match_midi("b? 69 7F",event)
	if ret~=nil then
		g_last_input_index = 4;
		local msg={ time_stamp=event.time_stamp, item=g_loop_button_index, value=1}
		remote.handle_input(msg)
		remote_on_auto_input(g_last_input_index)
	end


	-- -- Rewind
	-- ret = remote.match_midi("b? 67 7F",event)
	-- if ret~=nil then
	-- 	g_last_input_index = 5;
	-- end


	-- -- Fast Forward
	-- ret = remote.match_midi("b? 68 7F",event)
	-- if ret~=nil then
	-- 	g_last_input_index = 6;
	-- end


	-- Tap Tempo
	ret = remote.match_midi("b? 6d 7F",event)
	if ret~=nil then
		g_last_input_index = 7;
		local msg={ time_stamp=event.time_stamp, item=g_taptempo_button_index, value=1}
		remote.handle_input(msg)
		remote_on_auto_input(g_last_input_index)
		g_tap_tempo_led = 1
	end

	ret = remote.match_midi("b? 6d 00",event)
	if ret~=nil then
		g_tap_tempo_led = 0
	end


	-- -- Metro
	-- ret = remote.match_midi("b? 66 7F",event)
	-- if ret~=nil then
	-- 	g_last_input_index = 8;
	-- 	g_init_param = 0
	-- 	g_metro_button_state = toggle_metro_button_state()
	-- 	local msg={ time_stamp=event.time_stamp, item=g_metro_button_index, value=1}
	-- 	remote.handle_input(msg)
	-- 	return true
	-- end


	-- Switch
	ret = remote.match_midi("b? 76 7F",event)
	if ret~=nil then
		g_switch_button_state = toggle_switch_button_state()
		g_last_input_index = 9;
	end


	-- Navigation
	ret = remote.match_midi("b? 1C <?x??>?",event)
	if ret~=nil then
		if g_switch_button_state == "channel" then
			g_last_input_index = 10;
			local msg={ time_stamp=event.time_stamp, item=g_channel_index, value=(2*ret.x-1)}
			remote.handle_input(msg)
		else
			g_last_input_index = 11;
			local msg={ time_stamp=event.time_stamp, item=g_preset_index, value=(2*ret.x-1)}
			remote.handle_input(msg)
		end
	end


	-- Song Position
	ret = remote.match_midi("b? 1D <?x??>?",event)
	if ret~=nil then
		g_last_input_index = 12;
		local msg={ time_stamp=event.time_stamp, item=g_song_pos_index, value=(2*ret.x-1)*15360 }
		remote.handle_input(msg)
		temp = g_song_pos_state + (2*ret.x-1)*15360
		if temp > -15360 then
			g_song_pos_state = g_song_pos_state + (2*ret.x-1)*15360
			--g_time_pos = get_time_pos(g_song_pos_state)
		end
	end



	--Faders
	ret = remote.match_midi("B0 0E yy",event)
	if ret~=nil then
		g_last_input_index = 13
		g_fader_1_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end


	ret = remote.match_midi("B0 0F yy",event)
	if ret~=nil then
		g_last_input_index = 14
		g_fader_2_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end

	ret = remote.match_midi("B0 1E yy",event)
	if ret~=nil then
		g_last_input_index = 15
		g_fader_3_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)		
	end

	ret = remote.match_midi("B0 1F yy",event)
	if ret~=nil then
		g_last_input_index = 16
		g_fader_4_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)		
	end

	-- Knob
	ret = remote.match_midi("B0 56 yy",event)
	if ret~=nil then
		g_last_input_index = 17
		g_knob_1_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end

	ret = remote.match_midi("B0 57 yy",event)
	if ret~=nil then
		g_last_input_index = 18
		g_knob_2_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end

	ret = remote.match_midi("B0 59 yy",event)
	if ret~=nil then
		g_last_input_index = 19
		g_knob_3_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end

	ret = remote.match_midi("B0 5A yy",event)
	if ret~=nil then
		g_last_input_index = 20
		g_knob_4_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end

	ret = remote.match_midi("B0 6E yy",event)
	if ret~=nil then
		g_last_input_index = 21
		g_knob_5_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end

	ret = remote.match_midi("B0 6F yy",event)
	if ret~=nil then
		g_last_input_index = 22
		g_knob_6_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end

	ret = remote.match_midi("B0 74 yy",event)
	if ret~=nil then
		g_last_input_index = 23
		g_knob_7_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end
	
	ret = remote.match_midi("B0 75 yy",event)
	if ret~=nil then
		g_last_input_index = 24
		g_knob_8_HW_value = ret.y
		local msg={ time_stamp=event.time_stamp, item=g_last_input_index, value=ret.y}
		remote.handle_input(msg)
	end

	ret = remote.match_midi("<100z>9 xx yy",event)
	if ret~=nil then
		--PAD_ID = tonumber(ret.x)
		PAD_ID = tonumber(ret.x)-35
		if PAD_ID < 9 then 
			g_last_input_index = 110
		else 
			g_last_input_index = 111
		end
		
		if ret.y == 0 then
			PAD_MATRIX_STATE[PAD_ID] = 0
		else
			PAD_MATRIX_STATE[PAD_ID] = 1
		end
	end


	ret = remote.match_midi("f0 00 20 6b 7f 42 21 11 40 5d 00 xx 00 f7", event)
	if ret~=nil then
		MEMORY = "1"
	end

	return false
end



function remote_deliver_midi(max_bytes, port)

	
	local ret_events={}

	-- Screen Line 1 update
	if (g_lcd_line1_new_text ~= g_lcd_line1_old_text) or (g_lcd_line2_new_text ~= g_lcd_line2_old_text) then
		g_lcd_line1_old_text = g_lcd_line1_new_text
		g_lcd_line2_old_text = g_lcd_line2_new_text
		table.insert(ret_events, make_lcd_midi_message(g_lcd_line1_new_text, g_lcd_line2_new_text, 0, 10))
	end

	-- Screen recover
	if (g_last_input_index == 100) then
		table.insert(ret_events,make_lcd_midi_message(g_lcd_line1_old_text, g_lcd_line2_old_text, 0, 10))
		g_last_input_index = 0
	end

	if (REC_STATUS ~= REC_STATUS_old) then
		REC_STATUS_old = REC_STATUS
		table.insert(ret_events, make_lcd_midi_message(g_lcd_line1_new_text, g_lcd_line2_new_text, 0, 10))
	end

	if (PLAY_STATUS ~= PLAY_STATUS_old) then
		PLAY_STATUS_old = PLAY_STATUS
		table.insert(ret_events, make_lcd_midi_message(g_lcd_line1_new_text, g_lcd_line2_new_text, 0, 10))
	end

	-- Pads



	if (g_last_input_index == 4) then
		table.insert(ret_events, make_lcd_midi_message("Loop Mode", g_loop_button_state, 0, 10))
		-- table.insert(ret_events,make_lcd_midi_message("Loop",tostring(item),10))  
	end
	
	-- if (g_last_input_index == 5) then
	-- 	table.insert(ret_events,make_lcd_midi_message("Rewind","<<",10)) 
	-- end
	
	-- if (g_last_input_index == 6) then
	-- 	table.insert(ret_events,make_lcd_midi_message("Fast Forward",">>",10)) 
	-- end
	
	if (g_last_input_index == 7) then
		if g_tap_tempo_led == 1 then
			table.insert(ret_events,remote.make_midi("f0 00 20 6b 7f 42 02 02 16 5b 7f 7f 7f f7"))
		else
			table.insert(ret_events,remote.make_midi("f0 00 20 6b 7f 42 02 02 16 5b 28 28 28 f7"))
		end
		table.insert(ret_events,make_lcd_midi_message("Tempo", tostring(g_tempobpm) .. " BPM", 0, 10))
		--table.insert(ret_events,make_lcd_midi_message(MEMORY,MEMORY, 0, 10))
	end
	
	if (g_last_input_index == 8) then
		table.insert(ret_events,make_lcd_midi_message("Metronome", g_metro_button_state, 0, 10)) 
	end

	if (g_last_input_index == 12) then
		table.insert(ret_events,make_lcd_midi_message("Song Position", "["..g_bar..":"..g_beat.."]", 0, 10))
	end

	if (g_last_input_index == 110) then
		--table.insert(ret_events, PadRefresh(PAD_MATRIX_STATE))

		for i=1, 8 do
			if PAD_MATRIX_STATE[i] == 1 then
				table.insert(ret_events,remote.make_midi("f0 00 20 6b 7f 42 02 02 16 " .. string.format("%x", PAD_MATRIX[i]) .. " 58 58 58 f7"))
			else
				table.insert(ret_events,remote.make_midi("f0 00 20 6b 7f 42 02 02 16 " .. string.format("%x", PAD_MATRIX[i]) .. " 14 14 14 f7"))
			end
		end

	end

	if (g_last_input_index == 111) then
		--table.insert(ret_events, PadRefresh(PAD_MATRIX_STATE))

		for i=9, 16 do
			if PAD_MATRIX_STATE[i] == 1 then
				table.insert(ret_events,remote.make_midi("f0 00 20 6b 7f 42 02 02 16 " .. string.format("%x", PAD_MATRIX[i]) .. " 58 58 58 f7"))
			else
				table.insert(ret_events,remote.make_midi("f0 00 20 6b 7f 42 02 02 16 " .. string.format("%x", PAD_MATRIX[i]) .. " 14 14 14 f7"))
			end
		end

	end

	-- if (g_last_input_index == 111) then
	-- 	table.insert(ret_events,remote.make_midi("f0 00 20 6b 7f 42 02 02 16 " .. PAD_ID .. " 28 28 28 f7"))
	-- end

	-- Faders

	if (g_last_input_index == 13) then
		if g_fader_1_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Fader 1", tostring(g_fader_1_HW_value), g_fader_1_HW_value, 4))
		elseif g_fader_1_last_param == "Master " then
			table.insert(ret_events,make_lcd_midi_message("Master Bass:",g_fader_1_current_value_str, g_fader_1_HW_value, 4))
		else
			table.insert(ret_events,make_lcd_midi_message(g_fader_1_last_param, g_fader_1_current_value_str, g_fader_1_current_value_int, 4))
		end
	end

	if (g_last_input_index == 14) then
		if g_fader_2_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Fader 2",tostring(g_fader_2_HW_value), g_fader_2_HW_value, 4))
		elseif g_fader_1_last_param == "Master " then
			table.insert(ret_events,make_lcd_midi_message("Master Mid:",g_fader_2_current_value_str, g_fader_2_HW_value, 4))
		else
			table.insert(ret_events,make_lcd_midi_message(g_fader_2_last_param,g_fader_2_current_value_str, g_fader_2_current_value_int, 4))
		end 
	end

	if (g_last_input_index == 15) then
		if g_fader_3_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Fader 3",tostring(g_fader_3_HW_value), g_fader_3_HW_value, 4))
		elseif g_fader_1_last_param == "Master " then
			table.insert(ret_events,make_lcd_midi_message("Master Treble:",g_fader_3_current_value_str, g_fader_3_HW_value, 4))
		else
			table.insert(ret_events,make_lcd_midi_message(g_fader_3_last_param,g_fader_3_current_value_str, g_fader_3_current_value_int, 4))
		end
	end

	if (g_last_input_index == 16) then
		if g_fader_4_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Fader 4",tostring(g_fader_4_HW_value), g_fader_4_HW_value, 4))
		elseif g_fader_1_last_param == "Master " then
			table.insert(ret_events,make_lcd_midi_message("Master:",g_fader_4_current_value_str, g_fader_4_HW_value, 4))
		else
			table.insert(ret_events,make_lcd_midi_message(g_fader_4_last_param,g_fader_4_current_value_str, g_fader_4_current_value_int, 4))
		end
	end

	-- Knobs

	if (g_last_input_index == 17) then
		if g_knob_1_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Knob 1",tostring(g_knob_1_HW_value), g_knob_1_HW_value, 3))
		else
			table.insert(ret_events,make_lcd_midi_message(g_knob_1_last_param,g_knob_1_current_value_str, g_knob_1_current_value_int, 3))
		end
	end

	if (g_last_input_index == 18) then
		if g_knob_2_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Knob 2",tostring(g_knob_2_HW_value), g_knob_2_HW_value, 3))
		else
			table.insert(ret_events,make_lcd_midi_message(g_knob_2_last_param,g_knob_2_current_value_str, g_knob_2_current_value_int, 3))
		end
	end

	if (g_last_input_index == 19) then
		if g_knob_3_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Knob 3",tostring(g_knob_3_HW_value), g_knob_3_HW_value, 3))
		else
			table.insert(ret_events,make_lcd_midi_message(g_knob_3_last_param,g_knob_3_current_value_str, g_knob_3_current_value_int, 3))
		end
	end

	if (g_last_input_index == 20) then
		if g_knob_4_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Knob 4",tostring(g_knob_4_HW_value), g_knob_4_HW_value, 3))
		else
			table.insert(ret_events,make_lcd_midi_message(g_knob_4_last_param,g_knob_4_current_value_str, g_knob_4_current_value_int, 3))
		end
	end

	if (g_last_input_index == 21) then
		if g_knob_5_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Knob 5",tostring(g_knob_5_HW_value), g_knob_5_HW_value, 3))
		else
			table.insert(ret_events,make_lcd_midi_message(g_knob_5_last_param,g_knob_5_current_value_str, g_knob_5_current_value_int, 3))
		end
	end

	if (g_last_input_index == 22) then
		if g_knob_6_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Knob 6",tostring(g_knob_6_HW_value), g_knob_6_HW_value, 3))
		else
			table.insert(ret_events,make_lcd_midi_message(g_knob_6_last_param,g_knob_6_current_value_str, g_knob_6_current_value_int, 3))
		end
	end

	if (g_last_input_index == 23) then
		if g_knob_7_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Knob 7",tostring(g_knob_7_HW_value), g_knob_7_HW_value, 3))
		else
			table.insert(ret_events,make_lcd_midi_message(g_knob_7_last_param,g_knob_7_current_value_str, g_knob_7_current_value_int, 3))
		end
	end

	if (g_last_input_index == 24) then
		if g_knob_8_current_value_str == "Not mapped" then
			table.insert(ret_events,make_lcd_midi_message("Knob 8",tostring(g_knob_8_HW_value), g_knob_8_HW_value, 3))
		else
			table.insert(ret_events,make_lcd_midi_message(g_knob_8_last_param,g_knob_8_current_value_str, g_knob_8_current_value_int, 3))
		end
	end

	
	return ret_events
end

function remote_prepare_for_use()



	local retEvents={

		-- connect the MiniLab3 to Reason
		remote.make_midi("f0 00 20 6b 7f 42 02 02 40 6a 21 f7"),
		remote.make_midi("f0 00 20 6b 7f 42 02 02 40 6a 10 f7"),

		-- Display message on LCD
		make_lcd_midi_message("Reason", "Connected", 0, 10),
		remote.make_midi(ArturiaMessage()),


		-- LED connexion
		remote.make_midi("f0 00 20 6b 7f 42 02 02 16 34 14 14 14 f7"),
		remote.make_midi("f0 00 20 6b 7f 42 02 02 16 35 14 14 14 f7"),
		remote.make_midi("f0 00 20 6b 7f 42 02 02 16 36 14 14 14 f7"),
		remote.make_midi("f0 00 20 6b 7f 42 02 02 16 37 14 14 14 f7"),
		remote.make_midi("f0 00 20 6b 7f 42 02 02 16 38 14 14 14 f7"),
		remote.make_midi("f0 00 20 6b 7f 42 02 02 16 39 14 14 14 f7"),
		remote.make_midi("f0 00 20 6b 7f 42 02 02 16 3a 14 14 14 f7"),
		remote.make_midi("f0 00 20 6b 7f 42 02 02 16 3b 14 14 14 f7"),


	}
	return retEvents
end

function remote_release_from_use()
	local retEvents={
		-- Display message on LCD
		make_lcd_midi_message("Reason", "Disconnected", 0, 10),
	
		-- disconnect the MiniLab3 to Reason
		remote.make_midi("f0 00 20 6b 7f 42 02 02 40 6a 20 f7"),
		remote.make_midi("f0 00 20 6b 7f 42 02 02 40 6a 10 f7"),

	}
	return retEvents
end


-----------------------
-- Utility functions --
-----------------------


function stringToHex(text)
	local hexStringToReturn = ""
	for i=1, string.len(text) do
		if string.len(hexStringToReturn) > 0 then 
			hexStringToReturn = hexStringToReturn .. " "
		end
		hexStringToReturn = hexStringToReturn .. string.format("%X", string.byte(text,i))   
	end
	return hexStringToReturn
end

function make_lcd_midi_message(line1, line2, w_value, page_type)
	data_control = ""

	if page_type == 1 then
		data_control = ""
	end
	if page_type == 2 then
		data_control = "1F 02 01"
	end
	if page_type == 3 then
		if string.len(string.format("%x",w_value)) == 1 then
			data_control = "1F 03 01 0"..string.format("%x",w_value).." 00"
		else
			data_control = "1F 03 01 "..string.format("%x",w_value).." 00"
		end
	end
	if page_type == 4 then
		if string.len(string.format("%x",w_value)) == 1 then
			data_control = "1F 04 01 0"..string.format("%x",w_value).." 00"
		else
			data_control = "1F 04 01 "..string.format("%x",w_value).." 00"
		end
	end
	if page_type == 5 then
		data_control = "1F 05 01 00 00"
	end

	if page_type == 10 then
		data_control = "1F 07 01 " .. REC_STATUS .. "" .. PLAY_STATUS .. " 01 00"
	end

	local sysex = "f0 00 20 6b 7f 42 04 02 60 " .. data_control .. " 00 01" .. stringToHex(string.sub(line1,1,31)) .. " 00 02" .. stringToHex(string.sub(line2,1,31)) .. " 00 f7"
	local event=remote.make_midi(sysex)
	return event
end



function clear_display()
	return remote.make_midi("F0 00 20 29 02 0F 06 F7")
 end

function trace_event(event)
	result = "Event: "
	result = result .. "port " .. event.port .. ", "
	result = result .. (event.timestamp and ("timestamp " .. event.timestamp .. ", ") or "")
	result = result .. (event.hi and ("hi " .. event.hi .. ", ") or "")
	result = result .. (event.lo and ("lo " .. event.lo .. ", ") or "")
	result = result .. (event.size and ("size " .. event.size .. ", ") or "")

	result = result .. "data {"
	for i=1,event.size do
		result = result .. event[i] .. ", "
	end
	result = result .. "}, "

	remote.trace(result)
end


function get_time_pos(code_value)
	local unit
	unit = code_value/15360
	g_bar = math.floor(unit/4) + 1
	g_beat = math.fmod(unit,4)
	g_time_pos = "["..tostring(g_bar)..":"..tostring(g_beat).."]"
	return g_time_pos
end


function table.contains(table, element)
	present = false
	for _,value in pairs(table) do
		if value == element then
			present = true
		end
	end
	return present
end

function ArturiaMessage()
	local message = ""
	message = "f0 00 20 6b 7f 42 04 01 60 01" .. stringToHex("No Remote in Arturia") .. " 00 02" .. stringToHex("Go back to DAW") .. " 00 f7"
	return message
end

